//Se mettre sur le channel 16!!

#include "mbed.h"
#include "platform/mbed_thread.h"

#define SAMPLES     512 

Serial      debug_pc(USBTX, USBRX);

Serial bt(D8,D2); //TX, RX
Serial      dmx(A0, A1);
DigitalOut  out_tx(D5);
DigitalOut  start(D4);    //envoie des données
DigitalOut  enableDMX(D6);
AnalogIn    CV_volume(PC_1);
AnalogIn    CV_pitch(PB_0);

AnalogIn    variationR(PC_0);
AnalogIn    variationG(PC_2);
AnalogIn    variationB(PC_3);

AnalogIn x1_axis(A2);
AnalogIn y1_axis(A3);
AnalogIn color(D13);

// DMX
char dmx_data[SAMPLES] = {0};
char nb = 0;
void initDMX();
void updateDMX();


// MOSI, MISO, SCK, CSN, CE, IRQ
InterruptIn     my_bp(USER_BUTTON);

int power_on = 1;
int nb_appuis = 0;

// Main
int main()
{
    double x1_data;
    double y1_data;
    double color_data;
    char x;

    debug_pc.baud(9600);
    debug_pc.printf("Essai DMX512\r\n");


    initDMX();
    
    dmx_data[2] = 100; //Speed
    dmx_data[3] = 255; //Dimmer
    dmx_data[5] = 0; //R
    dmx_data[6] = 0; //G
    dmx_data[7] = 100; //B
    dmx_data[4] = 0; //Strobe

    updateDMX();

    char a = 0;
    
    while(1){   

    x1_data = x1_axis.read();
    y1_data = y1_axis.read();
    color_data = color.read();
    printf("\n%lf",x1_data);
    printf("\n%lf",y1_data);
    dmx_data[0] = x1_data*255; //PAN movement
    dmx_data[1] = y1_data*255; 
    
        
    if (bt.readable() == 1){
        char x = bt.getc();
        if (x == 'a'){
            dmx_data[3] = 100; //Dimmer
        }
        if (x == 'b'){
             dmx_data[3] = 0;
        }

        if (x == 'c'){
            dmx_data[4] = 249;
        }
        
        if (x == 'd') {
            dmx_data[4] = 0;
            }
        }
      
        
        double R;
        double G;
        double B;
        double angle_couleur = color_data*360.0;

        if (0.0<angle_couleur and angle_couleur<60.0){
            R = 255;
            G = (angle_couleur/60 * 255);
            B = 0;
        }

        
        if (60.0<angle_couleur and angle_couleur<120.0){
            R = ((120-angle_couleur)/60 * 255);
            G = 255;
            B = 0;
        }


        if (120.0<angle_couleur and angle_couleur<180.0){
            R = 0;
            G = 255;
            B = ((angle_couleur - 120)/60 * 255);      
        }


        if (180.0<angle_couleur and angle_couleur<240.0){
            R = 0;
            G = ((240-angle_couleur)/60 * 255);
            B = 255;
        }


        if (240.0<angle_couleur and angle_couleur<300.0){
            R = ((angle_couleur-240)/60 * 255);
            G = 0;
            B = 255;
        }

        if (300.0<angle_couleur){
            R = 255;
            G = 0;
            B = ((360-angle_couleur)/60 * 255);
        }
        
        dmx_data[5] = R;
        dmx_data[6] = G;
        dmx_data[7] = B;
        
        
        updateDMX();
        
    }
    
}


void initDMX(){
    // Initialisation DMX
    dmx.baud(250000);
    dmx.format (8, SerialBase::None, 2);
    enableDMX = 0;
    // Initialisation canaux DMX
    for(int k = 0; k < SAMPLES; k++){
        dmx_data[k] = 0;
    }    
    updateDMX();  
}

void updateDMX(){
        enableDMX = 1;
        start = 1;      // /start
        out_tx = 0;     // break
        wait_us(88);    
        out_tx = 1;     // mb
        wait_us(8);     
        out_tx = 0;     // break
        start = 0;
        dmx.putc(0);     // Start
        for(int i = 0; i < SAMPLES; i++){
            dmx.putc(dmx_data[i]);     // data
        }
        wait_us(23000); // time between frame  
}
